<?php
	const IRC_DATE_LONG 		= 1;
	const IRC_DATE_SHORT 		= 2;
	const IRC_DATE_SHORT_SECS	= 3;
	const IRC_DATE_SHORT_TAB	= 4;
	const IRC_DATE_DIRECT		= 5;
	
	
	if (!isset($argv[1])) {
		die("No filename specified.");
	}
	
	$h = fopen($argv[1], 'r') or die;
	
	$modeSet 	= NULL;
	$curSec		= NULL;
	$prevSec	= NULL;
	$sleep2		= false;
	
	while ($l = fgets($h)) {
		// Blank lines skipped
		$l = trim($l);
		if (!$l) {
			continue;
		} else {
			$l .= "\n";
		}
		
		if (!$modeSet) {
			// Not determined date format yet
			if ($l[0] == "(") {
				if ($l[1] == "\t") {
					$modeSet 	= IRC_DATE_SHORT_TAB;
					$prevSec 	= 'X';
				} else if ($l[9] == ")") {
					$modeSet 	= IRC_DATE_SHORT_SECS;
					$prevSec 	= (int) substr($l, 7, 2); //14, 8);			
				} else if ($l[22] == ")") {
					$modeSet 	= IRC_DATE_LONG;
					$prevSec 	= (int) substr($l, 20, 2); //14, 8);					
				}
			} else if ($l[0] == "[") {
				$modeSet 	= IRC_DATE_SHORT;
				$prevSec		= 'X'; // Mark as not numeric for permanent sleep(2)
			} else if (is_numeric($l[0]) && @is_numeric($l[17])) {
				$modeSet 	= IRC_DATE_DIRECT;
				$prevSec		= (int) substr($l, 17, 2);
			} else {
				echo $l;
				continue;
			}			
		}
		
		if ($modeSet == IRC_DATE_LONG) {
			$curSec 	= substr($l, 20, 2);
			$outLn		= substr($l, 24);
		} else if ($modeSet == IRC_DATE_SHORT) {
			$sleep2 	= ($l[0] == "[");	// Determine if the format is valid (if not, print whole line)
			$outLn		= substr($l, 8);
		} else if ($modeSet == IRC_DATE_SHORT_SECS) {
			$curSec 	= (int) substr($l, 7, 2);
			$outLn		= substr($l, 11);
		} else if ($modeSet == IRC_DATE_SHORT_TAB) {
			// Proper formatting
			$sleep2 	= ($l[1] == "\t") ;
			$outLn		= "<" . str_replace("\t:\t", "> ", substr($l, 20));
		} else if ($modeSet == IRC_DATE_DIRECT) {
			$curSec		= (int) substr($l, 17, 2);
			$outLn		= "<" . str_replace("\t:\t", "> ", substr($l, 20));
		}
		
		// Determine sleep time
		if (is_numeric($curSec)) {
			if ($prevSec > $curSec) {
				$time = 60 - $prevSec + $curSec;
			//} elseif ($prevSec == $curSec) {
			//	$time = mt_rand(2, 4);
			} else {
				$time = $curSec - $prevSec;
			}
			sleep($time);
			echo $outLn;
			
		} else if ($sleep2) {
			sleep(2);
			echo $outLn;
		} else {
			// Badly formatted newline
			sleep(2);
			echo $l;
		}
		$prevSec = $curSec;
	}
	
	fclose($h);
	die;